Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 584)
+++ /trunk/configure.ac	(revision 1)
@@ -1,20 +1,41 @@
-dnl We want to override the standard _AC_INIT_PARSE_ARGS
-dnl
-AU_ALIAS([_AC_INIT_PARSE_ARGS], [SH_INIT_PARSE_ARGS], [], [silent])
-dnl AU_ALIAS([_AC_INIT_help], [SH_INIT_HELP])
-
-AC_INIT([samhain],[4.5.2])
-AC_CONFIG_SRCDIR(src/samhain.c)
-
-AC_ARG_VAR([LIBS], [libraries to link against, e.g. -lintl])
+dnl We want to override the standard AC_INIT_PARSE_ARGS,
+dnl which requires replacing AC_INIT() with its expanded
+dnl content.
+dnl
+dnl include own macros
+dnl
+sinclude(acsite.m4)dnl
+sinclude(./aclocal.m4)dnl
+
+dnl
+dnl AC_INIT(samhain.c)
+dnl
+# Forbidden tokens and exceptions.
+m4_pattern_forbid([^_?A[CHUM]_])
+m4_pattern_forbid([_AC_])
+m4_pattern_forbid([^LIBOBJS$],
+                  [do not use LIBOBJS directly, use AC_LIBOBJ (see section `AC_LIBOBJ vs. LIBOBJS'])
+# Actually reserved by M4sh.
+m4_pattern_allow([^AS_FLAGS$])
+AS_INIT
+dnl m4_ifval([$2], [_AC_INIT_PACKAGE($@)])
+_AC_INIT_DEFAULTS
+SH_INIT_PARSE_ARGS
+_AC_INIT_SRCDIR
+SH_INIT_HELP
+_AC_INIT_VERSION
+_AC_INIT_CONFIG_LOG
+_AC_INIT_PREPARE
+_AC_INIT_NOTICE
+_AC_INIT_COPYRIGHT
+m4_ifval([$2], , [m4_ifval([$1], [AC_CONFIG_SRCDIR([$1])])])dnl
+
+AC_ARG_VAR([LIBS],
+            [libraries to link against, e.g. -lintl])
 
 dnl
 dnl start
 dnl
-dnl AM_INIT_AUTOMAKE
-m4_pattern_allow([AC_DEFINE])
-AC_DEFINE([SAMHAIN], 1, [Application is samhain])
-AC_DEFINE_UNQUOTED([VERSION], [_("${PACKAGE_VERSION}")], [Current version] )
-AC_DEFINE_UNQUOTED([PACKAGE], [_("${PACKAGE_NAME}")], [Application name] )
+AM_INIT_AUTOMAKE(samhain, 2.1.1)
 AC_CANONICAL_HOST
 
@@ -24,43 +45,22 @@
 
 AC_PROG_CC
-if test "$host" != "$build"; then
-   AC_CHECK_PROGS(BUILD_CC, gcc cc)
-else
-   BUILD_CC=$CC
-fi
 AC_PROG_CPP 
 AC_PROG_INSTALL
 AC_PROG_LN_S
 AC_PROG_AWK
-SH_PROG_LD
 AC_PATH_PROG(cmd_hostname,hostname)
 AC_SUBST(cmd_hostname)
-AC_SUBST(BUILD_CC)
-
-
-if test "x$GCC" = "xyes"; then
-   SH_GCC_VERSION
-fi
-
-if test "x${gcc_VERSION_MAJOR}" != "x"
-then
-	AC_MSG_CHECKING([for gcc compiler issues])
-	if test ${gcc_VERSION_MAJOR} -ge 11
-	then
-		dnmalloc_ok=no
-		AC_MSG_RESULT([dnmalloc does not work with gcc 11])
-	else
-		dnmalloc_ok=yes
-		AC_MSG_RESULT([ok])
-	fi	
-else
-	dnmalloc_ok=yes
-fi
-
-
-AC_CHECK_HEADERS([sys/ipc.h sys/sem.h sys/msg.h sys/uio.h fcntl.h])
-
-
-AC_MSG_CHECKING([for OS specific issues])
+
+GCC_STACK_PROTECT_CC
+
+AC_HEADER_STDC
+dnl
+dnl first one is a dummy because of an autoconf bug
+dnl (no HAVE_... for first one)
+dnl 
+AC_CHECK_HEADERS([sys/ipc.h sys/msg.h sys/uio.h fcntl.h])
+
+
+AC_MSG_CHECKING([for host-specific issues])
 mydebugflag=no
 myneedg3=no
@@ -69,6 +69,4 @@
 mynetbsd=no
 sh_use_lcaps="undef"
-sh_use_pie=yes
-enable_asm_ok=yes
 
 case "$host_os" in
@@ -76,19 +74,15 @@
 	*linux*)
 	sh_use_lcaps="yes"
-	AC_DEFINE([HOST_IS_LINUX], [1], [] )
-        AC_DEFINE([HAVE_EXT2_IOCTLS], [1], [] )
-	AC_MSG_RESULT([use ioctl to get e2fs flags])
+	AC_DEFINE(HOST_IS_LINUX)
+        AC_DEFINE(HAVE_EXT2_IOCTLS)
+	AC_MSG_RESULT(LINUX use ioctl to get e2fs flags)
 	case "$host_cpu" in 
 	   i*86*)
-	   AC_DEFINE([HOST_IS_I86LINUX], [1], [] )
-	   ;;
-	   x86_64)
-	   AC_DEFINE([HOST_IS_64LINUX], [1], [Define if host OS is 64bit Linux])
+	   AC_DEFINE(HOST_IS_I86LINUX)
 	   ;;
 	   *)
 	   ;;
 	esac
-	LDFLAGS="${LDFLAGS} -Wl,--as-needed"
-	;;
+        ;;
 	
 	*osf*)
@@ -98,77 +92,46 @@
 	  CFLAGS="$CFLAGS -O2 -assume noaligned_objects"
 	  myneedg3=yes
-	  AC_MSG_RESULT([compiler needs assume noaligned_objects])
+	  AC_MSG_RESULT(OSF1 compiler needs assume noaligned_objects)
 	else
-	  AC_MSG_RESULT([none])
+	  AC_MSG_RESULT(none)
         fi
         ;;
 	
 	*cygwin*) 
-	AC_DEFINE([HOST_IS_CYGWIN], [1], [] )
-	AC_DEFINE([USE_REGISTRY_CHECK], 1, [Define for registry check])
-	dnmalloc_ok=no
-	enable_asm_ok=no
-	AC_MSG_RESULT([no trusted paths, no dnmalloc. no asm optimize])
+	AC_DEFINE(HOST_IS_CYGWIN)
+	AC_MSG_RESULT(CYGWIN do not check for trusted paths)
 	;;
 
-	*darwin*|*apple*) 
-	AC_DEFINE([HOST_IS_DARWIN], [1], [] )
-	dnmalloc_ok=no
-	AC_MSG_RESULT([check resource forks, no dnmalloc])
+	*darwin*) 
+	AC_DEFINE(HOST_IS_DARWIN)
+	AC_MSG_RESULT(DARWIN check resource forks)
 	;;
 
-	*freebsd7*)
-	AC_DEFINE([HOST_IS_FREEBSD], [1], [] )
+	*freebsd*)
+	AC_DEFINE(HOST_IS_FREEBSD)
 	selectconfig=freebsd
-	case "$host_cpu" in
-		amd64|x86_64)
-		sh_use_pie=no
-		dnmalloc_ok=no
-		AC_MSG_RESULT([no dnmalloc and broken compiler toolchain])
-		;;
-		*)
-		AC_MSG_RESULT([none])
-		;;
-	esac
-	;;
-	
-	*freebsd*)
-	AC_DEFINE([HOST_IS_FREEBSD], [1], [] )
-	selectconfig=freebsd
-	case "$host_cpu" in
-		amd64|x86_64)
-		dnmalloc_ok=no
-		AC_MSG_RESULT([no dnmalloc])
-		;;
-		*)
-		AC_MSG_RESULT([none])
-		;;
-	esac
-	AC_MSG_RESULT([none])
+	AC_MSG_RESULT(none)
 	;;
 	
 	*openbsd*)
-	AC_DEFINE([HOST_IS_OPENBSD], 1, [Define if host OS is OPENBSD])
 	selectconfig=freebsd
-	dnmalloc_ok=no
-	AC_MSG_RESULT([dnmalloc does not work with pthreads])
+	AC_MSG_RESULT(none)
 	;;
 
 	*netbsd*)
 	mynetbsd=yes
-	selectconfig=netbsd
-	AC_MSG_RESULT([bug with libresolve])
+	AC_MSG_RESULT(NETBSD bug with libresolve)
 	;;
 
         *solaris*)
 	selectconfig=solaris
-	AC_DEFINE([HOST_IS_SOLARIS], [1], [] )
+	AC_DEFINE(HOST_IS_SOLARIS)
 	case "$host_cpu" in
 		i*86)
-		AC_DEFINE([HOST_IS_I86SOLARIS], [1], [] )
-		AC_MSG_RESULT([vsnprintf prototype])
+		AC_DEFINE(HOST_IS_I86SOLARIS)
+		AC_MSG_RESULT(SOLARIS I86 vsnprintf prototype)
 		;;
 		*)
-		AC_MSG_RESULT([none])
+		AC_MSG_RESULT(none)
 		;;
 	esac
@@ -190,10 +153,10 @@
         *sun*)
 	selectconfig=solaris
-	AC_DEFINE([HOST_IS_SOLARIS], [1], [])
-	AC_MSG_RESULT([none])
+	AC_DEFINE(HOST_IS_SOLARIS)
+	AC_MSG_RESULT(none)
         ;;
 
 	*aix*)
-        AC_DEFINE([HOST_IS_AIX], [1], [aix])
+        AC_DEFINE(HOST_IS_AIX)
 	selectconfig=aix5.2.0
 	uid_cast="unsigned long"
@@ -208,19 +171,19 @@
     		CFLAGS="$CFLAGS -qstrict"
   	  fi
-          AC_MSG_RESULT([AIX size_t in the accept call and optimize O3 qstrict])
+          AC_MSG_RESULT(AIX size_t in the accept call and optimize O3 qstrict)
 	else
-          AC_MSG_RESULT([AIX size_t in the accept call])
+          AC_MSG_RESULT(AIX size_t in the accept call)
         fi
         ;;
 	
         *hpux*)
-        AC_MSG_RESULT([HPUX need _XOPEN_SOURCE_EXTENDED for h_errno])
-	AC_DEFINE([HOST_IS_HPUX], [1], [hpux])
+        AC_MSG_RESULT(HPUX has not always h_errno defined)
+	AC_DEFINE(HOST_IS_HPUX)
 	if test "x$GCC" != "xyes"; then
   	  if test ! -z "`echo "$CFLAGS" | grep "\-g" 2> /dev/null`" ; then
     		CFLAGS=`echo $CFLAGS | sed 's%\-g%%' `
   	  fi
-  	  if test -z "`echo "$CFLAGS" | grep "\+O2" 2> /dev/null`"; then
-    		CFLAGS="$CFLAGS +O2"
+  	  if test -z "`echo "$CFLAGS" | grep "\-fast" 2> /dev/null`"; then
+    		CFLAGS="$CFLAGS -fast"
   	  fi
 	fi
@@ -228,16 +191,15 @@
 
         *ultrix*)
-        AC_MSG_RESULT([ULTRIX getcwd uses popen])
-        AC_DEFINE([HAVE_BROKEN_GETCWD], [1], [bad implementation of getcwd])
+        AC_MSG_RESULT(ULTRIX getcwd uses popen)
+        AC_DEFINE(HAVE_BROKEN_GETCWD)
         ;;
 
         *)
-        AC_MSG_RESULT([none])
+        AC_MSG_RESULT(none)
         ;;
 esac
 
 AC_SUBST(selectconfig)
-AC_DEFINE_UNQUOTED([UID_CAST], [${uid_cast}], [basic type to which we can cast a uid])
-
+AC_DEFINE_UNQUOTED(UID_CAST, ${uid_cast})
 
 
@@ -250,25 +212,15 @@
 AC_HEADER_DIRENT
 AC_HEADER_MAJOR
-AC_CHECK_HEADERS([sys/time.h])
+AC_HEADER_TIME
 dnl used in minilzo.c
 AC_HEADER_STAT
-
-AC_CHECK_DECLS([sys_siglist], [], [],
-[#include <signal.h>
-/* NetBSD declares sys_siglist in unistd.h.  */
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif
-])
-
-AC_CHECK_HEADERS(stddef.h libgen.h sched.h malloc.h sys/uio.h \
-	sys/mman.h sys/param.h sys/inotify.h sys/sysmacros.h \
-	sys/vfs.h mntent.h \
-	sys/select.h sys/socket.h netinet/in.h ifaddrs.h \
-	regex.h glob.h fnmatch.h \
-	linux/ext2_fs.h linux/fs.h ext2fs/ext2_fs.h asm/segment.h \
-	elf.h linux/elf.h auparse.h \
-	paths.h arpa/nameser.h arpa/nameser_compat.h \
-	rpc/rpcent.h rpc/rpc.h sys/statvfs.h,
+AC_DECL_SYS_SIGLIST 
+
+AC_CHECK_HEADERS(stddef.h libgen.h sched.h \
+	sys/vfs.h \
+	sys/select.h sys/socket.h netinet/in.h \
+	regex.h glob.h \
+	linux/ext2_fs.h ext2fs/ext2_fs.h \
+	paths.h arpa/nameser.h arpa/nameser_compat.h,
 	[],
 	[],
@@ -279,90 +231,20 @@
 AC_CHECK_HEADER(utmpx.h, sh_utmpx="yes", sh_utmpx="no")
 if test "x$sh_utmpx" = "xyes"; then
-  AC_DEFINE([HAVE_UTMPX_H], [1], [whether we have utmpx.h])
-  AC_EGREP_HEADER(ut_host, utmpx.h, AC_DEFINE([HAVE_UTHOST], [1], [] ))
-  AC_EGREP_HEADER(ut_addr, utmpx.h, AC_DEFINE([HAVE_UTADDR], [1], [] ))
-  AC_EGREP_HEADER(ut_addr_v6, utmpx.h, AC_DEFINE([HAVE_UTADDR_V6], [1], [] ))
-  AC_EGREP_HEADER(ut_xtime,utmpx.h, AC_DEFINE([HAVE_UTXTIME], [1], [] ))
-  AC_EGREP_HEADER(ut_type, utmpx.h, AC_DEFINE([HAVE_UTTYPE], [1], [] ))
+  if cat "/usr/include/utmpx.h" 2>&5 |
+    	egrep "WTMPX_FILE" >/dev/null 2>&1; then
+  		AC_DEFINE(HAVE_UTMPX_H)
+  		AC_EGREP_HEADER(ut_host, utmpx.h, AC_DEFINE(HAVE_UTHOST) )
+  		AC_EGREP_HEADER(ut_addr, utmpx.h, AC_DEFINE(HAVE_UTADDR) )
+  		AC_EGREP_HEADER(ut_xtime,utmpx.h, AC_DEFINE(HAVE_UTXTIME) )
+  		AC_EGREP_HEADER(ut_type, utmpx.h, AC_DEFINE(HAVE_UTTYPE) )
+  else
+  		AC_EGREP_HEADER(ut_addr, utmp.h, AC_DEFINE(HAVE_UTADDR) )
+  		AC_EGREP_HEADER(ut_host, utmp.h, AC_DEFINE(HAVE_UTHOST) )
+  		AC_EGREP_HEADER(ut_type, utmp.h, AC_DEFINE(HAVE_UTTYPE) )
+  fi
 else
-  AC_EGREP_HEADER(ut_addr, utmp.h, AC_DEFINE([HAVE_UTADDR], [1], [] ))
-  AC_EGREP_HEADER(ut_host, utmp.h, AC_DEFINE([HAVE_UTHOST], [1], [] ))
-  AC_EGREP_HEADER(ut_type, utmp.h, AC_DEFINE([HAVE_UTTYPE], [1], [] ))
-fi
-
-dnl
-dnl figure out where acct.h lives
-dnl and whether fields are int/comp_t
-dnl
-dnl GNU Accounting Utilities
-dnl Copyright (C) 1993, 1996, 1997, 2003, 2005 Free Software Foundation, Inc.
-dnl The GNU Accounting Utilities are free software; you can redistribute
-dnl them and/or modify them under the terms of the GNU General Public
-dnl License as published by the Free Software Foundation; either version
-dnl 2, or (at your option) any later version.
-dnl
-AC_CHECK_HEADER(sys/acct.h,
-		AC_DEFINE(HAVE_SYS_ACCT_H, ,
-			  [Define if you have the <sys/acct.h> header file.])
-		AC_EGREP_HEADER(ac_utime, sys/acct.h,
-				AC_DEFINE(HAVE_ACUTIME, ,
-					  [Define if <sys/acct.h> has the AC_UTIME field.])
-				AC_EGREP_HEADER(comp_t.*ac_utime, sys/acct.h,
-						AC_DEFINE(ACUTIME_COMPT, ,
-							  [Define if <sys/acct.h>'s AC_UTIME field is a COMP_T.]))
-		)
-		AC_EGREP_HEADER(ac_stime, sys/acct.h,
-				AC_DEFINE(HAVE_ACSTIME, ,
-					  [Define if <sys/acct.h> has the AC_STIME field.])
-				AC_EGREP_HEADER(comp_t.*ac_stime, sys/acct.h,
-						AC_DEFINE(ACSTIME_COMPT, ,
-							  [Define if <sys/acct.h>'s AC_STIME field is a COMP_T.]))
-		)
-		AC_EGREP_HEADER(ac_etime, sys/acct.h,
-				AC_DEFINE(HAVE_ACETIME, ,
-					  [Define if <sys/acct.h> has the AC_ETIME field.])
-				AC_EGREP_HEADER(comp_t.*ac_etime, sys/acct.h,
-						AC_DEFINE(ACETIME_COMPT, ,
-							  [Define if <sys/acct.h>'s AC_ETIME field is a COMP_T.]))
-		)
-		AC_EGREP_HEADER(ac_io,    sys/acct.h,
-				AC_DEFINE(HAVE_ACIO, ,
-					  [Define if <sys/acct.h> has the AC_IO field.])
-				AC_EGREP_HEADER(comp_t.*ac_io,    sys/acct.h,
-						AC_DEFINE(ACIO_COMPT, ,
-							  [Define if <sys/acct.h>'s AC_IO field is a COMP_T.]))
-		)
-		AC_EGREP_HEADER(ac_mem,   sys/acct.h,
-				AC_DEFINE(HAVE_ACMEM, ,
-					  [Define if <sys/acct.h> has the AC_MEM field.])
-				AC_EGREP_HEADER(comp_t.*ac_mem,   sys/acct.h,
-						AC_DEFINE(ACMEM_COMPT, ,
-							  [Define if <sys/acct.h>'s AC_MEM field is a COMP_T.]))
-		)
-		AC_EGREP_HEADER(ac_minflt,   sys/acct.h,
-				AC_EGREP_HEADER(ac_majflt,   sys/acct.h,
-						AC_EGREP_HEADER(ac_swaps,   sys/acct.h,
-								AC_DEFINE(HAVE_PAGING, ,
-									  [Define if <sys/acct.h> has the AC_MINFLT, AC_MAJFLT and AC_SWAPS fields.])
-								AC_EGREP_HEADER(comp_t.*ac_minflt, sys/acct.h,
-										AC_DEFINE(ACMINFLT_COMPT, ,
-											  [Define if <sys/acct.h>'s AC_MINFLT field is a COMP_T.]))
-								AC_EGREP_HEADER(comp_t.*ac_mayflt, sys/acct.h,
-										AC_DEFINE(ACMAJFLT_COMPT, ,
-											  [Define if <sys/acct.h>'s AC_MAJFLT field is a COMP_T.]))
-								AC_EGREP_HEADER(comp_t.*ac_swaps, sys/acct.h,
-										AC_DEFINE(ACSWAPS_COMPT, ,
-											  [Define if <sys/acct.h>'s AC_SWAPS field is a COMP_T.]))
-						)
-				)
-		)
-		AC_EGREP_HEADER(comp_t,   sys/acct.h, AC_DEFINE(HAVE_COMP_T, ,
-								[Define if <sys/acct.h> uses the COMP_T type.]))
-		AC_EGREP_HEADER([struct acct_v3],   sys/acct.h, AC_DEFINE(HAVE_ACCT_V3, ,
-								[Define if <sys/acct.h> has struct acct_v3.]))
-		AC_EGREP_HEADER([struct acctv2],    sys/acct.h, AC_DEFINE(HAVE_ACCTV2, ,
-								[Define if <sys/acct.h> has struct acctv2.]))
-
- )
+  AC_EGREP_HEADER(ut_host, utmp.h, AC_DEFINE(HAVE_UTHOST) )
+  AC_EGREP_HEADER(ut_type, utmp.h, AC_DEFINE(HAVE_UTTYPE) )
+fi
 
 dnl need to check because AIX 4.2 does not have it
@@ -397,67 +279,45 @@
 dnl *****************************************
 AC_FUNC_STRFTIME
-AC_CHECK_FUNCS(memcmp memcpy memmove memset getpwent endpwent fpurge \
-        explicit_memset explicit_bzero \
+AC_CHECK_FUNCS(memcmp memcpy memmove memset getpwent endpwent \
 	gettimeofday strlcat strlcpy strstr strchr strerror strsignal \
 	seteuid setreuid setresuid lstat getwd getcwd ptrace \
 	usleep setpriority getpeereid nanosleep \
-	strptime basename sched_yield hasmntopt \
+	strptime basename sched_yield \
 	inet_aton gethostbyname setutent setrlimit gethostname uname \
-	initgroups getpagesize getutxent \
-	ttyname fchmod writev mmap tzset \
-	getsid getpriority getpgid statvfs \
-	strerror_r getgrgid_r getpwnam_r getpwuid_r \
-	gmtime_r localtime_r rand_r readdir_r strtok_r \
-	mincore posix_fadvise inotify_init1 scandir
-)
-AC_CHECK_FUNC([statfs], [
-			AC_DEFINE([HAVE_STATFS], [1], [have statfs func])
-			statfs="yes"
-			], [statfs="no"])
+	initgroups getpagesize \
+	ttyname fchmod
+)
+AC_CHECK_FUNC(statfs, AC_DEFINE(HAVE_STATFS) statfs="yes",  statfs="no")
 SL_CHECK_VA_COPY
 AC_CHECK_FUNCS(vsnprintf, [SL_CHECK_VSNPRINTF])
 AC_CHECK_MLOCK
-SH_STRFTIME_Z
 
 AC_MSG_CHECKING(how to get filesystem type)
 fstype=no
 # The order of these tests is important.
-AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <sys/statvfs.h>
-#include <sys/fstyp.h>
-]])], [
-      AC_DEFINE([FSTYPE_STATVFS], [1], [statvfs])
-      fstype=SVR4])
-
+AC_TRY_CPP([#include <sys/statvfs.h>
+#include <sys/fstyp.h>], AC_DEFINE(FSTYPE_STATVFS) fstype=SVR4)
 if test $fstype = no; then
-AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <sys/statfs.h>
-#include <sys/fstyp.h>
-]])], [
-      AC_DEFINE([FSTYPE_USG_STATFS], [1], [usg])
-      fstype=SVR3])
-fi
-
+AC_TRY_CPP([#include <sys/statfs.h>
+#include <sys/fstyp.h>], AC_DEFINE(FSTYPE_USG_STATFS) fstype=SVR3)
+fi
 if test $fstype = no; then
-AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <sys/statfs.h>
-#include <sys/vmount.h>
-]])], AC_DEFINE([FSTYPE_AIX_STATFS], [1], [aix]) fstype=AIX)
-fi
-
+AC_TRY_CPP([#include <sys/statfs.h>
+#include <sys/vmount.h>], AC_DEFINE(FSTYPE_AIX_STATFS) fstype=AIX)
+fi
 if test $fstype = no; then
-AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <mntent.h>
-]])], AC_DEFINE([FSTYPE_MNTENT], [1], [mtent]) fstype=4.3BSD)
-fi
-
+AC_TRY_CPP([#include <mntent.h>], AC_DEFINE(FSTYPE_MNTENT) fstype=4.3BSD)
+fi
 if test $fstype = no; then
-AC_EGREP_HEADER(f_type;, sys/mount.h, AC_DEFINE([FSTYPE_STATFS], [1], [statfs]) fstype=4.4BSD/OSF)
-fi
-
+AC_EGREP_HEADER(f_type;, sys/mount.h, AC_DEFINE(FSTYPE_STATFS) fstype=4.4BSD/OSF)
+fi
 if test $fstype = no; then
-AC_PREPROC_IFELSE([AC_LANG_SOURCE([[#include <sys/mount.h>
-#include <sys/fs_types.h>
-]])], AC_DEFINE([FSTYPE_GETMNT], [1], [getmnt]) fstype=Ultrix)
+AC_TRY_CPP([#include <sys/mount.h>
+#include <sys/fs_types.h>], AC_DEFINE(FSTYPE_GETMNT) fstype=Ultrix)
 fi
 AC_MSG_RESULT($fstype)
 
 sh_libsocket=
+
 dnl Solaris needs -lsocket and -lnsl. Unisys system includes
 dnl gethostbyname in libsocket but needs libnsl for socket.
@@ -494,18 +354,4 @@
   ]) 
 
-AC_CHECK_FUNCS( getnameinfo getaddrinfo )
-
-
-sh_auparse=no
-
-if test "x$ac_cv_header_auparse_h" = "xyes"
-then
-   AC_CHECK_LIB(auparse, auparse_find_field, [
-   			 LIBS="$LIBS -lauparse"
-			 sh_auparse=yes
-			 AC_DEFINE([HAVE_AUPARSE_LIB], [1], [Define if you have the auparse lib])
-			 ])
-fi
-
 dnl arguments for accept
 
@@ -519,6 +365,5 @@
 
 AC_MSG_CHECKING(for socklen_t)
-AC_COMPILE_IFELSE(
-[AC_LANG_PROGRAM([[
+AC_TRY_COMPILE([
 #ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
@@ -528,12 +373,9 @@
 #endif
   socklen_t x;
-]], [[]])],
-[
+], [],[
   AC_MSG_RESULT(yes)
   AC_DEFINE_UNQUOTED([ACCEPT_TYPE_ARG3],[socklen_t], [type of arg3 of accept])
-  AC_DEFINE([HAVE_SOCKLEN_T], 1, [Define if you have socklen_t])
 ],[
-  AC_COMPILE_IFELSE(
-	[AC_LANG_PROGRAM([[
+  AC_TRY_COMPILE([
 #ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
@@ -543,6 +385,5 @@
 #endif
     int accept (int, struct sockaddr *, size_t *);
-    ]],[[]])],
-    [
+    ],[],[
       AC_MSG_RESULT(size_t)
       AC_DEFINE_UNQUOTED([ACCEPT_TYPE_ARG3],[size_t], [type of arg3 of accept])
@@ -554,24 +395,4 @@
 ])
 
-dnl *****************************************
-dnl     checks for extended attribute or ACL 
-dnl     support
-dnl *****************************************
-
-AC_ARG_ENABLE([selinux],
-	[AS_HELP_STRING([--enable-selinux], [support checking selinux attributes])],
-	[],
-	[enable_selinux=check])
-if test "x$enable_selinux" != xno; then
-   sh_CHECK_XATTR
-fi
-
-AC_ARG_ENABLE([posix-acl],
-	[AS_HELP_STRING([--enable-posix-acl], [support checking posix acls])],
-	[],
-	[enable_posix_acl=check])
-if test "x$enable_posix_acl" != xno; then
-   sh_CHECK_POSIX_ACL
-fi
 
 dnl *****************************************
@@ -579,14 +400,10 @@
 dnl *****************************************
 
-AC_TYPE_LONG_DOUBLE
+AC_C_LONG_DOUBLE
 SH_CHECK_TYPEDEF(long long, HAVE_LONG_LONG)
-SH_CHECK_TYPEDEF(uint16_t, HAVE_UINT16_T)
-SH_CHECK_TYPEDEF(uint32_t, HAVE_UINT32_T)
-SH_CHECK_TYPEDEF(uint64_t, HAVE_UINT64_T)
 if test "$sh_HAVE_LONG_LONG" = "yes"; then
    AC_CHECK_SIZEOF(unsigned long long, 4)
-   sh_sizeof_unsigned_long_long=`echo "$ac_cv_sizeof_unsigned_long_long" | sed 's%[^0-9]%%g'`
-   if test "$sh_sizeof_unsigned_long_long" = "8"; then
-      AC_DEFINE([HAVE_LONG_LONG_64], [1], [Define if you have 64bit long long])
+   if test "$ac_cv_sizeof_unsigned_long_long" = "8"; then
+      AC_DEFINE(HAVE_LONG_LONG_64, 1, [Define if you have 64bit long long])
    fi
 fi
@@ -598,29 +415,27 @@
 
 AC_CHECK_SIZEOF(unsigned long,  4)
-AC_CHECK_SIZEOF(unsigned int,   4)
+AC_CHECK_SIZEOF(unsigned int ,  4)
 AC_CHECK_SIZEOF(unsigned short, 2)
     
 
-sh_sizeof_unsigned_long=`echo "$ac_cv_sizeof_unsigned_long" | sed 's%[^0-9]%%g'`
-if test "$sh_sizeof_unsigned_long"  = "4"; then
-	AC_DEFINE([HAVE_LONG_32], [1], [long32])
-fi
-if test "$sh_sizeof_unsigned_long"  = "8"; then
-	AC_DEFINE([HAVE_LONG_64], [1], [long64])
-fi
-sh_sizeof_unsigned_int=`echo "$ac_cv_sizeof_unsigned_int" | sed 's%[^0-9]%%g'`
-if test "$sh_sizeof_unsigned_int"   = "4"; then
-	AC_DEFINE([HAVE_INT_32], [1], [int32])
-fi
-sh_sizeof_unsigned_short=`echo "$ac_cv_sizeof_unsigned_short" | sed 's%[^0-9]%%g'`
-if test "$sh_sizeof_unsigned_short" = "4"; then
-	AC_DEFINE([HAVE_SHORT_32], [1], [short32])
-fi
-
-dnl 
-dnl check for 64 bit programming environment
-dnl
-SAMHAIN_64
-
+if test "$ac_cv_sizeof_unsigned_long" = "4"; then
+	AC_DEFINE(HAVE_LONG_32)
+fi
+if test "$ac_cv_sizeof_unsigned_long" = "8"; then
+	AC_DEFINE(HAVE_LONG_64)
+fi
+if test "$ac_cv_sizeof_unsigned_int" = "4"; then
+	AC_DEFINE(HAVE_INT_32)
+fi
+
+dnl
+dnl For Alpha
+dnl
+if test "$ac_cv_sizeof_unsigned_int_" = "4"; then
+	AC_DEFINE(HAVE_INT_32)
+fi
+if test "$ac_cv_sizeof_unsigned_short" = "4"; then
+	AC_DEFINE(HAVE_SHORT_32)
+fi
 
 dnl *****************************************
@@ -635,28 +450,19 @@
 AC_MSG_CHECKING(whether struct stat has a st_flags field)
 AC_CACHE_VAL(e2fsprogs_cv_struct_st_flags,
-        AC_COMPILE_IFELSE(
-		[AC_LANG_PROGRAM([[
-#include <sys/stat.h>
-]],
-                [[struct stat stat; stat.st_flags = 0;]])],
+        AC_TRY_COMPILE([#include <sys/stat.h>],
+                [struct stat stat; stat.st_flags = 0;],
                 [e2fsprogs_cv_struct_st_flags=yes],
-                [e2fsprogs_cv_struct_st_flags=no]
-		))
+                [e2fsprogs_cv_struct_st_flags=no]))
 AC_MSG_RESULT($e2fsprogs_cv_struct_st_flags)
-
 if test "$e2fsprogs_cv_struct_st_flags" = yes; then
   AC_MSG_CHECKING(whether st_flags field is useful)
   AC_CACHE_VAL(e2fsprogs_cv_struct_st_flags_immut,
-        AC_COMPILE_IFELSE(
-		[AC_LANG_PROGRAM([[
-#include <sys/stat.h>
-]],
-                [[struct stat stat; stat.st_flags |= UF_IMMUTABLE;]])],
+        AC_TRY_COMPILE([#include <sys/stat.h>],
+                [struct stat stat; stat.st_flags |= UF_IMMUTABLE;],
                 [e2fsprogs_cv_struct_st_flags_immut=yes],
-                [e2fsprogs_cv_struct_st_flags_immut=no]
-		))
+                [e2fsprogs_cv_struct_st_flags_immut=no]))
   AC_MSG_RESULT($e2fsprogs_cv_struct_st_flags_immut)
   if test "$e2fsprogs_cv_struct_st_flags_immut" = yes; then
-          AC_DEFINE([HAVE_STAT_FLAGS], [1], [Have stat flags])
+          AC_DEFINE(HAVE_STAT_FLAGS)
   fi
 fi
@@ -666,77 +472,59 @@
 dnl
 AC_MSG_CHECKING(for struct cmsgcred)
-AC_COMPILE_IFELSE(
-  [AC_LANG_PROGRAM([[
+AC_TRY_COMPILE([
 #include <sys/types.h>
 #include <sys/socket.h>
-]],[[
+],[
 struct cmsgcred cred;
 
 cred.cmcred_pid = 0;
-]])],sh_have_struct_cmsgcred=yes,sh_have_struct_cmsgcred=no)
+],sh_have_struct_cmsgcred=yes,sh_have_struct_cmsgcred=no)
 AC_MSG_RESULT($sh_have_struct_cmsgcred)
 
 if test x$sh_have_struct_cmsgcred = xyes; then
-    AC_DEFINE([HAVE_STRUCT_CMSGCRED], [1], [Have cmsgcred structure])
+    AC_DEFINE(HAVE_STRUCT_CMSGCRED,1,[Have cmsgcred structure])
 fi
 
 AC_MSG_CHECKING(for struct fcred)
-AC_COMPILE_IFELSE(
-  [AC_LANG_PROGRAM([[
+AC_TRY_COMPILE([
 #include <sys/param.h>
 #include <sys/socket.h>
 #include <sys/ucred.h>
-]],[[
+],[
 struct fcred sockcred;
-]])],sh_have_struct_fcred=yes,sh_have_struct_fcred=no)
+],sh_have_struct_fcred=yes,sh_have_struct_fcred=no)
 AC_MSG_RESULT($sh_have_struct_fcred)
 
 if test x$sh_have_struct_fcred = xyes; then
-    AC_DEFINE([HAVE_STRUCT_FCRED], [1], [Have fcred structure])
+    AC_DEFINE(HAVE_STRUCT_FCRED,1,[Have fcred structure])
 fi
 
 AC_MSG_CHECKING(for struct sockcred)
-AC_COMPILE_IFELSE(
-  [AC_LANG_PROGRAM([[
+AC_TRY_COMPILE([
 #include <sys/param.h>
 #include <sys/socket.h>
 #include <sys/ucred.h>
-]],[[
+],[
 struct sockcred sockcred;
-]])],sh_have_struct_sockcred=yes,sh_have_struct_sockcred=no)
+],sh_have_struct_sockcred=yes,sh_have_struct_sockcred=no)
 AC_MSG_RESULT($sh_have_struct_sockcred)
 
 if test x$sh_have_struct_sockcred = xyes; then
-    AC_DEFINE([HAVE_STRUCT_SOCKCRED], [1], [Have sockcred structure])
+    AC_DEFINE(HAVE_STRUCT_SOCKCRED,1,[Have sockcred structure])
 fi
 
 AC_MSG_CHECKING(for SO_PEERCRED)
-AC_COMPILE_IFELSE(
-  [AC_LANG_PROGRAM([[
+AC_TRY_COMPILE([
 #include <sys/types.h>
 #include <sys/socket.h>
-]],[[
+],[
 int test = SO_PEERCRED;
-]])],sh_have_SO_PEERCRED=yes,sh_have_SO_PEERCRED=no)
+],sh_have_SO_PEERCRED=yes,sh_have_SO_PEERCRED=no)
 AC_MSG_RESULT($sh_have_SO_PEERCRED)
 
 if test x$sh_have_SO_PEERCRED = xyes; then
-    AC_DEFINE([HAVE_SO_PEERCRED], [1], [Have SO_PEERCRED define])
-fi
-
-AC_MSG_CHECKING(for union semun)
-AC_COMPILE_IFELSE(
-  [AC_LANG_PROGRAM([[
-#include <sys/types.h>
-#include <sys/ipc.h>
-#include <sys/sem.h>
-]],[[
-union semun foo;
-]])], [sh_have_semun=yes], [sh_have_semun=no])
-AC_MSG_RESULT($sh_have_semun)
-if test x$sh_have_semun = xyes
-then
-  AC_DEFINE([HAVE_UNION_SEMUN], [1], [union semun already defined in sys/ipc.h or sys/sem.h])
-fi
+    AC_DEFINE(HAVE_SO_PEERCRED,1,[Have SO_PEERCRED define])
+fi
+
 
 dnl *****************************************
@@ -746,29 +534,7 @@
 AC_C_CONST
 AC_C_BIGENDIAN
-AC_C_RESTRICT
 
 AM_SA_SIGACTION_WORKS
 
-AC_ARG_ENABLE(ssp,
-	[  --disable-ssp		disable the GCC stack protector],
-	[],
-	[enable_ssp=yes;]
-)
-
-if test "x$GCC" = "xyes"; then
-
-   if test x"${enable_ssp}" = xno; then
-      :
-   else
-	GCC_STACK_PROTECT_LIB
-   	GCC_STACK_PROTECT_CC
-	GCC_STACK_CHECK_CC
-	GCC_PIE_CC
-	GCC_FLAG_CHECK([-fexceptions])
-	GCC_FLAG_CHECK([-mcet -fcf-protection])
-   fi	
-
-fi
-
 dnl *****************************************
 dnl
@@ -776,12 +542,4 @@
 dnl
 dnl *****************************************
-
-dnl
-dnl check for /proc filesystem
-dnl
-if test -d "/proc/$$"
-then
-        AC_DEFINE([HAVE_PROCFS], [1], [Define if you have a proc fs])
-fi
 
 dnl
@@ -796,59 +554,8 @@
 then
 	# LIBS="-lgmp $LIBS"
-	AC_DEFINE([HAVE_LIBGMP], [1], [Have GNU gmp library])
+	AC_DEFINE(HAVE_LIBGMP, 1, [Have GNU gmp library])
 fi
 AC_CHECK_HEADERS(gmp.h)
 
-AC_MSG_CHECKING([for ps])
-PS=
-for ff in /usr/ucb /bin /usr/bin; do
-    if test -x "$ff/ps"; then
-       PS="$ff/ps"
-       AC_MSG_RESULT([$PS])
-       break
-    fi
-done
-if test x$PS = x
-then
-	AC_MSG_RESULT([no])
-	AC_MSG_ERROR([Cannot find ps in any of /usr/ucb /bin /usr/bin])
-fi
-AC_DEFINE_UNQUOTED([PSPATH], [_("$PS")], [Path to ps executable])
-
-AC_MSG_CHECKING([how to use ps])
-$PS ax >/dev/null 2>&1
-if test $? -eq 0; then
-   case "$host_os" in
-   *openbsd*)
-   one=`$PS akx | wc -l`
-   ;;
-   *)
-   one=`$PS ax | wc -l`
-   ;;
-   esac
-else
-   one=0
-fi
-$PS -e >/dev/null 2>&1
-if test $? -eq 0; then
-   two=`$PS -e | wc -l`
-else
-   two=0
-fi
-if test $one -ge $two 
-then
-   case "$host_os" in
-   *openbsd*)
-	PSARG="akx"
-	;;
-   *)
-	PSARG="ax"
-	;;
-   esac
-else
-	PSARG="-e"
-fi
-AC_DEFINE_UNQUOTED([PSARG], [_("$PSARG")], [Argument for ps])
-AC_MSG_RESULT([$PS $PSARG])
 
 dnl *****************************************
@@ -859,8 +566,8 @@
 
 AC_ARG_ENABLE(db-reload,
-	[  --enable-db-reload		enable database reload on SIGHUP [[no]]],
+	[  --enable-db-reload		enable database reload on SIGHUP [no]],
 	[
 	if test "x${enable_db_reload}" = xyes; then
-		AC_DEFINE([RELOAD_DATABASE], [1], [database reload on SIGHUP])
+		AC_DEFINE(RELOAD_DATABASE)
 	fi
 	]
@@ -871,5 +578,5 @@
 	[
 	if test "x${enable_xml_log}" = xyes; then
-		AC_DEFINE([SH_USE_XML], [1], [logfile in XML format])
+		AC_DEFINE(SH_USE_XML)
 	fi
 	]
@@ -883,29 +590,8 @@
 		:
 	else
-		AC_DEFINE([SH_WITH_MAIL], [1], [internal SMTP mailer])
+		AC_DEFINE(SH_WITH_MAIL)
 	fi
 	],
-	[AC_DEFINE([SH_WITH_MAIL], [1], [internal SMTP mailer])]
-)
-
-AC_ARG_ENABLE(suid,
-	[  --enable-suid		allow suid],
-	[
-	if test "x${enable_suid}" = xyes; then
-		AC_DEFINE(SH_ALLOW_SUID, [1], [Define if you want to allow suid execution for samhain])
-	fi
-	]
-)
-
-AC_ARG_ENABLE(shellexpand,
-	[  --disable-shellexpand		disable shell expansion in config file],
-	[
-	if test "x${enable_shellexpand}" = xno; then
-		:
-	else
-		AC_DEFINE(SH_EVAL_SHELL, [1], [Define if you want shell expansion in configuration file])
-	fi
-	],
-	[AC_DEFINE(SH_EVAL_SHELL, [1], [Define if you want shell expansion in configuration file])]
+	[AC_DEFINE(SH_WITH_MAIL)]
 )
 
@@ -916,8 +602,8 @@
                 :
 	else
-		AC_DEFINE([WITH_EXTERNAL], [1], [can use external scripts])
+		AC_DEFINE(WITH_EXTERNAL)
         fi
         ],
-	[AC_DEFINE([WITH_EXTERNAL], [1], [can use external scripts])]
+	[AC_DEFINE(WITH_EXTERNAL)]
 )
 
@@ -925,25 +611,15 @@
        [  --enable-message-queue[[=MODE]]	enable SysV message queue [[MODE=0700]]],
        [
-       if test "x${ac_cv_header_sys_msg_h}" = "xyes"; then
-	   if test "x${enable_message_queue}" = xyes; then
-	       AC_DEFINE([WITH_MESSAGE_QUEUE], [1], [SysV message queue])
-	       AC_DEFINE_UNQUOTED([MESSAGE_QUEUE_MODE], [0700], [mode of message queue])
-	   elif test "x${enable_message_queue}" != xno; then
-	       echo "${enableval}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
-		   AC_MSG_ERROR([With --enable-message-queue=MODE, MODE must be numeric])
-	       echo "${enableval}" | \
-		   grep ['0[0123456789][0123456789][0123456789]'] >/dev/null 2>&1 ||
-		   AC_MSG_ERROR([With --enable-message-queue=MODE, MODE must be an octal (0nnn) number])
-               AC_DEFINE([WITH_MESSAGE_QUEUE], [1], [SysV message queue])
-               AC_DEFINE_UNQUOTED([MESSAGE_QUEUE_MODE], [${enable_message_queue}], [mode of message queue])
-           fi
-       else
-           echo
-	   echo "**********************************************"
-           echo
-           AC_MSG_WARN([sys/msg.h missing, --enable-message-queue disabled])
-           echo
-           echo "**********************************************"
-           echo
+       if test "x${enable_message_queue}" = xyes; then
+               AC_DEFINE(WITH_MESSAGE_QUEUE)
+               AC_DEFINE_UNQUOTED(MESSAGE_QUEUE_MODE, 0700)
+       elif test "x${enable_message_queue}" != xno; then
+		echo "${enableval}" | grep ['[^0123456789]'] >/dev/null 2>&1 &&
+			AC_MSG_ERROR([--enable-message-queue: MODE must be numeric])
+		echo "${enableval}" | \
+			grep ['0[0123456789][0123456789][0123456789]'] >/dev/null 2>&1 ||
+			AC_MSG_ERROR([--enable-message-queue: MODE must be an octal (0nnn) number])
+               	AC_DEFINE(WITH_MESSAGE_QUEUE)
+               	AC_DEFINE_UNQUOTED(MESSAGE_QUEUE_MODE, ${enable_message_queue})
        fi
        ]
@@ -975,5 +651,5 @@
 LIBWRAP_INC=""
 AC_ARG_WITH(libwrap,
-[  --with-libwrap[=PATH]		Compile in libwrap (TCP Wrappers) support],
+[ --with-libwrap[=PATH]	Compile in libwrap (TCP Wrappers) support],
 [ AC_MSG_RESULT($withval)
   case "$withval" in
@@ -1006,15 +682,10 @@
      AC_CHECK_HEADER(tcpd.h,
 		     [],
-		     [ AC_MSG_ERROR([Could not find tcpd.h for libwrap. You need to install tcp_wrappers.]) ])
-     AC_LINK_IFELSE(
-	[AC_LANG_PROGRAM([[
-#include <tcpd.h>
-]],[[
-int allow_severity;
-int deny_severity; 
-hosts_access((struct request_info *) 0); ]])],
-	[ AC_DEFINE([SH_USE_LIBWRAP], [1], [Build with tcp wrapper support]) ],
-	[ AC_MSG_ERROR([Could not find the libwrap library.]) ]
-	)
+		     [ AC_MSG_ERROR([Could not find tcpd.h for libwrap. You must first install tcp_wrappers]) ])
+     AC_TRY_LINK([ #include <tcpd.h>
+		   int allow_severity; int deny_severity; ],
+		 [ hosts_access((struct request_info *) 0); ],
+		 [ AC_DEFINE(SH_USE_LIBWRAP,1,[Build with tcp wrapper support]) ],
+		 [ AC_MSG_ERROR([Could not find the libwrap library.]) ])
   fi ],
   AC_MSG_RESULT(no)
